#include <amxmodx>

#define _MAX_LEN_EXCEPTION 256

#define try() 	if( !__try() ){		\
					return ;		\
				}					\
				else

#define catch(%1) 	if( !__catch( %1 ) ){	\
						return ;			\
					}						\
					else

#define raise(%1,%2) 	__raise( %1 , %2 ); \
						return
						
new stock Array: __currentExceptions	=	Array:0;
new stock Array: __currentMessages		=	Array:0;

new stock __lastExcept[]			=	"";
new stock __lastMessage[]			=	"";

new stock const __fileToLog[]	=	"addons/amxmodx/logs/exceptions.log";

stock bool: __try(){
	
	if( _:__currentExceptions <= 0 ){
		__currentExceptions	=	ArrayCreate( _MAX_LEN_EXCEPTION , 1 );
		__currentMessages	=	ArrayCreate( _MAX_LEN_EXCEPTION , 1 );
	}
	
	if( __checkIsNullException() ){
		return true;
	}
	
	return false;
}

stock __raise( exceptionName[] , exceptionMessage[] ){
	ArrayPushString( __currentExceptions , exceptionName );
	ArrayPushString( __currentMessages , exceptionMessage );
}

stock bool: __catch( szString[] ){
	
	new szStringTmp[ _MAX_LEN_EXCEPTION ],
		iFound		=	-1;
	
	new iLen 	= strlen( szString ),
		outLen 	=	0;
	
	do{
		outLen += 1 + copyc( szStringTmp , _MAX_LEN_EXCEPTION , szString[ outLen ] , ' ' );
		
		if( ( iFound = __checkCatch( szStringTmp ) ) != -1 ){
				
			break;
				
		}
	} while( outLen < iLen );
	
	if( iFound != -1 ){
		
		__copyException( iFound );
		
		__deleteExceptions( iFound );
		
		return true;
	}
	
	return false;
}

stock __checkCatch( szStringTmp[] ){
	
	new tmpArray[ _MAX_LEN_EXCEPTION ];
	
	for( new iCurrent = ArraySize( __currentExceptions ) - 1; iCurrent >= 0 ; iCurrent++ ){
		ArrayGetString( __currentExceptions , iCurrent , tmpArray , _MAX_LEN_EXCEPTION - 1 );
		
		if( equal( tmpArray , szStringTmp ) ){
			return iCurrent;
		}
	}
	
	return -1;
}

stock __deleteExceptions( iItem ){
	ArrayDeleteItem( __currentExceptions , iItem );
	ArrayDeleteItem( __currentMessages , iItem );
}

stock bool: __checkIsNullException(){
	return ArraySize( __currentExceptions ) == 0;
}

stock __copyException( iItem ){
	ArrayGetString( __currentExceptions , iItem , __lastExcept , _MAX_LEN_EXCEPTION - 1 );
	ArrayGetString( __currentMessages , iItem , __lastMessage , _MAX_LEN_EXCEPTION - 1 );
}
	
stock getExceptName( exceptName[] , maxSize ){
	copy( exceptName , maxSize , __lastExcept );
}

stock getExceptMessage( exceptMessage[] , maxSize ){
	copy( exceptMessage , maxSize , __lastMessage );
}

stock clearExcepts( exceptsList[] ){
	new szStringTmp[ _MAX_LEN_EXCEPTION ];
	
	new iLen 	= strlen( exceptsList ),
		outLen 	=	0;
	
	do{
		outLen += 1 + copyc( szStringTmp , _MAX_LEN_EXCEPTION , exceptsList[ outLen ] , ' ' );
		
		clearExcept( szStringTmp );
	} while( outLen < iLen );
}

stock clearExcept( szExcept[] ){
	new tmpArray[ _MAX_LEN_EXCEPTION ];
	
	for( new iCurrent = 0; iCurrent < ArraySize( __currentExceptions ) ; iCurrent++ ){
		ArrayGetString( __currentExceptions , iCurrent , tmpArray , _MAX_LEN_EXCEPTION - 1 );
		
		if( equal( tmpArray , szExcept ) ){
			ArrayDeleteItem( __currentExceptions , iCurrent );
			ArrayDeleteItem( __currentMessages , iCurrent );
			
			iCurrent--;
		}
	}
}